

#define DebugPrint(p) 
//Serial.println(p)

// you have forward declare the "callback" functions
extern void SecondsLeap(byte secs);
extern void MinuteLeap(byte h,byte m,byte d,byte mon,unsigned short year,byte wof);

#define DCF77_LED_REPLICAPIN -1 // -1 to disable LED replica, note that an active LED can influence the DCF77 module in weired ways
#define DCF77_PARTIALOK true // accept partial results
#define DCF77_MAXMOVINGAVERAGE 3 // in seconds, set to 0 to disable
#define DCF77_MINDRIFTCORRECTION 3 // maxdrift allowed before correcting the drift in msecs
#define DCF77_Pin 2
#define DCF77_INTNR 0
#define DCF77_MINUTECALLBACK(h,m,d,mon,year,wof) MinuteLeap(h,m,d,mon,year,wof)
#define DCF77_SECONDCALLBACK(sec) SecondsLeap(sec)

#include <DCF77ISR.h>

void setup(void)
{
    DCF77ISR::setup(); // pin, int
    Serial.begin(9600);
}


int lastState=-1;
unsigned long nextStats=0;

void SecondsLeap(byte secs)
{
	Serial.print("s=");
	Serial.println(secs,DEC);
}

void MinuteLeap(byte h,byte m,byte d,byte mon,unsigned short year,byte wof)
{
	char outb[32];
	sprintf(outb,"%2d:%2d %2d/%2d/%4d (%d)", h, m, d, mon, year, wof);
	Serial.println(outb);
}



void loop(void) {
    if (millis()>nextStats)
    {
        nextStats=millis()+5000;
 		char outb[256];
		sprintf(outb,"good=%2d bad=%4d assigned=%2d double=%d doubt=%d drift=%4d ", DCF77ISR::goodCnt, DCF77ISR::badCnt, DCF77ISR::assignCnt, DCF77ISR::assignDoubleCnt, DCF77ISR::doubtAssigned,DCF77ISR::driftPerMinute);
		Serial.print(outb);
		Serial.println(DCF77ISR::bitAssigned);       
    }
	if (DCF77ISR::assigned!=DCF77ISR::MA_NONE)
	{
		if (DCF77ISR::assigned==DCF77ISR::MA_BAD)
			Serial.println("not assigned, some bad data!");
		char outb[256];
		sprintf(outb,"good=%2d bad=%4d assigned=%2d double=%d doubt=%d drift=%4d ", DCF77ISR::goodCnt, DCF77ISR::badCnt, DCF77ISR::assignCnt, DCF77ISR::assignDoubleCnt, DCF77ISR::doubtAssigned,DCF77ISR::driftPerMinute);
		Serial.println (outb);
		sprintf(outb,"%2d:%2d %2d/%2d/%4d (%d)", DCF77ISR::hour, DCF77ISR::min, DCF77ISR::day, DCF77ISR::month, DCF77ISR::year, DCF77ISR::weekday);
		Serial.println(outb);
		Serial.println(DCF77ISR::bitAssigned);
		DCF77ISR::ResetMinuteStuff();
	}
}
